﻿using NHibernate.Criterion;
using NHibernate.Dialect;
using NUnit.Framework;

namespace NHibernate.Test.NHSpecificTest.NH2214
{
    [TestFixture]
    public class SampleTest : BugTestCase
    {
        protected override void OnSetUp()
        {
            base.OnSetUp();
            using (ISession session = this.OpenSession())
            {
                DomainClass entity = new DomainClass {Id = 1, Name = "Name"};
                session.Save(entity);
                
                entity = new DomainClass {Id = 2, Name = "Name"};
                session.Save(entity);
                
                entity = new DomainClass {Id = 3, Name = "Name1"};
                session.Save(entity);
                
                entity = new DomainClass {Id = 4, Name = "Name1"};
                session.Save(entity);

                entity = new DomainClass { Id = 5, Name = "Name2" };
                session.Save(entity);

                entity = new DomainClass { Id = 6, Name = "Name2" };
                session.Save(entity);

                entity = new DomainClass { Id = 7, Name = "Name3" };
                session.Save(entity);

                entity = new DomainClass { Id = 8, Name = "Name3" };
                session.Save(entity);
                
                session.Flush();
            }
        }

        protected override void OnTearDown()
        {
            base.OnTearDown();
            using (ISession session = this.OpenSession())
            {
                string hql = "from System.Object";
                session.Delete(hql);
                session.Flush();
            }
        }

        protected override bool AppliesTo(NHibernate.Dialect.Dialect dialect)
        {
            return dialect as MsSql2005Dialect != null;
        }

        [Test]
        public void QueryWithDistinctShouldBeRetrievedCorrectly()
        {
            using (ISession session = this.OpenSession())
            {
                int page = 2;
                int rows = 2;

                var criteria = DetachedCriteria.For<DomainClass>("d")
                      .SetProjection(Projections.Distinct(Projections.ProjectionList()
                      .Add(Projections.Property("Name"))
                     ))
                     .SetFirstResult((page - 1) * rows)
                     .SetMaxResults(rows)
                     .AddOrder(Order.Asc("Name"))
                     ;

                var crit = criteria.GetExecutableCriteria(session);
                var result = crit.List();

                Assert.AreEqual("Name2", result[0]);
                Assert.AreEqual("Name3", result[1]); 
            }
        }
    }
}
